/*  Copyright @ 2018 gamefreak955

	All rights reserved.
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:

	1. Redistributions of source code must retain the above copyright notice, this
	list of conditions and the following disclaimer.
	2. Redistributions in binary form must reproduce the above copyright notice,
	this list of conditions and the following disclaimer in the documentation
	and/or other materials provided with the distribution.
	3. Neither the name of this organization nor the names of its contributors may
	be used to endorse or promote products derived from this software without
	specific prior written permission.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
	ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
	DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
	ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
	LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
	ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
	SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

	The views and conclusions contained in the software and documentation are those
	of the authors and should not be interpreted as representing official policies,
	either expressed or implied, of gamefreak955.
*/


#ifndef __File_Util_H__
#define __File_Util_H__


#include <vector>
#include <string>
#include <ctime>
#include <limits>
#include <sstream>
#include <iostream>
#include <algorithm>
#include <experimental/filesystem> // C++-standard header file name  
#include <filesystem> // Microsoft-specific implementation header file name  

using namespace std;
using namespace std::experimental::filesystem::v1;


/*Returns file list of dir */
std::vector<std::experimental::filesystem::path> Find_Files(const std::experimental::filesystem::path &dir);
bool Find_Files(const std::experimental::filesystem::path &dir, std::vector<std::experimental::filesystem::path> &paths);

int File_Copy(const std::experimental::filesystem::path target, const std::experimental::filesystem::path destination, std::vector<std::string> &extensions);
bool Rename_File(std::experimental::filesystem::path target, std::experimental::filesystem::path destination);

/*removes .nca and .xml files from
./4nxci_extracted_xci */
bool Erase_Temporary_Files(std::experimental::filesystem::path Converter_Filepath);

/*  cAsE SeNSItve, include file extension with name
	eg. COOL_guy.awesome
	Returns:
	SUCCESS = path vector with entries only containing extensions from extensions parameter
	FAILURE = an empty path vector	*/
std::vector<std::experimental::filesystem::path> return_files_with_extentions(const std::vector<std::experimental::filesystem::path> &paths, const std::vector<std::string> &extensions);
std::vector<std::experimental::filesystem::path> return_files_with_extentions(const std::vector<std::experimental::filesystem::path> &paths, const std::string &extension);

/*cAsE SeNSItve, include period with the extension name eg .sexy */
bool has_extension(const std::experimental::filesystem::path &fp, const std::vector<std::string> &extensions);
bool has_extension(const std::experimental::filesystem::path &fp, const std::string &extension);

/*removes .ext*/
std::experimental::filesystem::path remove_extention(std::experimental::filesystem::path filename);


/*returns str wrapped in "" */
std::string makequote(const std::string &str);

void press_enter_to_continue();
#endif
