/*  Copyright @ 2018 gamefreak955

	All rights reserved.
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:

	1. Redistributions of source code must retain the above copyright notice, this
	list of conditions and the following disclaimer.
	2. Redistributions in binary form must reproduce the above copyright notice,
	this list of conditions and the following disclaimer in the documentation
	and/or other materials provided with the distribution.
	3. Neither the name of this organization nor the names of its contributors may
	be used to endorse or promote products derived from this software without
	specific prior written permission.

	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
	ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
	DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
	ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
	(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
	LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
	ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
	SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

	The views and conclusions contained in the software and documentation are those
	of the authors and should not be interpreted as representing official policies,
	either expressed or implied, of gamefreak955.
*/


#ifndef _main_functions_
#define _main_functions_

#include "file_util.h"
#include "xci_file.h"
#include "titles.h"

#include <vector>
#include <string>
#include <sstream>
#include <iostream>
#include <algorithm>
#include <experimental/filesystem> // C++-standard header file name  
#include <filesystem> // Microsoft-specific implementation header file name  
using namespace std::experimental::filesystem::v1;


int Validate_Startup_Parameters(const std::experimental::filesystem::path XCI_File_DIR, const std::experimental::filesystem::path NSP_FileDestination, const std::experimental::filesystem::path Converter_Filepath);

//rename and move any existing nsp files
std::size_t Rename_NSP_Files(const std::experimental::filesystem::path Converter_Filepath, const std::experimental::filesystem::path NSP_FileDestination,  titles &Catalogue);

//convert xci to nsp
std::size_t Convert_XCI_Files(const std::experimental::filesystem::path Converter_Filepath, const std::experimental::filesystem::path NSP_FileDestination, const std::experimental::filesystem::path XCI_File_DIR, titles &Catalogue);
#endif